<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 04/25/2004 *
 * ===================                          Last change: 04/29/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : newsletter_functions.php                         *
 * -------------------------------------------------------------------- *
 * Short description : Functions for the HTML extension                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Funktionen fuer die HTML-Erweiterung             *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2016 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

//
function insertNewsletterUrls ($text) {
	$test = $text;

	// First replace URLs...
	while (isInString('http://', $test)) {
		$check = substr($test, strpos($test, 'http://')); $check2 = $check;

		// See ext-html.php if you want to add more URL ends...
		foreach ($GLOBALS['url_ends'] as $end) {
			if (isInString($end, $check)) {
				$check = substr($check, 0, strpos($check, $end));
			} // END - if
		} // END - foreach

		// Now replace the URL against anchor container and pray...
		$text = substr($text, 0, strpos($text, $check2)) . generateDereferrerUrl($check) . substr($text, strpos($text, $check2) + strlen($check));

		// Finally remove the url from testing string (or we have a loop and maybe server overload!)
		$test = substr($test, strpos($test, $check) + strlen($check));
	} // END - while

	// Now do the (nearly) same thing with email addresses
	// but now we have the problem that email addresses didn't have
	// a start mark like http:// and our templates are lame didn't have
	// a mailto: ... :-(
	$test = $text;

	// ... what will the email address be out the @... ;-)
	$PARTS = array();
	while (isInString('@', $test)) {
		$pos = strpos($test, '@');
		$test2 = substr($test, 0, $pos);

		// First check backwards
		$idx = $pos - 1;
		while ($idx > 0) {
			$check = substr($test2, $idx, 1);
			if (!in_array($check, $GLOBALS['valid_email_chars'])) {
				// Char found so we end here
				break;
			} // END - if
			$idx--;
		}

		if ($idx > 0) {
			// Starting mark is found
			$check2 = substr($test, 0, ($idx + 1));
			$test = substr($test, ($idx + 1));
		} // END - if

		// And now go forward...
		$idx = 0;
		while ($idx < strlen($test)) {
			$check = substr($test, $idx, 1);
			if ((!in_array($check, $GLOBALS['valid_email_chars'])) && ($check != '@')) {
				// Char found so end here again
				break;
			} // END - if
			$idx++;
		} // END - while

		if ($idx > 0) {
			// Maybe this is the email address?
			$check = substr($test, 0, $idx);
		} // END - if

		// Now replace the email against anchor with mailto and pray...
		array_push($PARTS, $check2 . $check);

		// Remove email from testing string (see above why...)
		$test = substr($test, strlen($check));
	} // END - while

	// Now put all parts together
	$text = '';
	array_push($PARTS, $test);
	foreach ($PARTS as $part) {
		$text .= $part;
	} // END - foreach

	// Pre-ompile possible own HTML tags out...
	return preCompileCode($text);
}

// Wrapper for sending newsletter and wrapping URLs / HTML mail
function sendNewsletter ($to, $subject, $message, $mode) {
	// Send mail away as HTML
	if (postRequestElement('auto_urls') == 'Y') {
		// Automatically insert URLs into newsletter
		if ((isExtensionActive('html_mail')) && ($mode == 'html')) {
			// Send HTML mail
			sendEmail($to, $subject, insertUrlsIntoHtml($message), 'Y');
		} else {
			// Send normal mail
			sendEmail($to, $subject, insertNewsletterUrls($message), 'N');
		}
	} else {
		// Regular send-out
		if ((isExtensionActive('html_mail')) && ($mode == 'html')) {
			sendEmail($to, $subject, $message, 'Y');
		} else {
			sendEmail($to, $subject, $message, 'N');
		}
	}
}

// [EOF]
?>
