<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 08/31/2004 *
 * ===================                          Last change: 11/14/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_bonus.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Configure "turbo-click-bonus"                    *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Einstellen der Turbo-Klick-Verguetungen          *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2016 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

if (isFormSent('save_config')) {
	// Replace german decimal comma with computer decimal dot
	convertCommaToDotInPostDataArray(array('login_bonus', 'turbo_bonus', 'bonus_ref', 'bonus_order', 'bonus_notify_points'));

	// Generate string for saving ranks
	setPostRequestElement('turbo_rates', '');
	$RATES = array();
	foreach (postRequestElement('rate') as $rate) {
		// Convert German comma to dot
		$rate = trim(convertCommaToDot($rate));

		if (!empty($rate)) {
			array_push($RATES, $rate);
		} // END - if
	} // END - foreach
	setPostRequestElement('turbo_rates', trim(implode(';', $RATES)));
	unsetPostRequestElement('rate');

	// Automatically calculate bonus points for ranks 2 and 3 when not set
	if (!isPostRequestElementSet('turbo_rates')) {
		setPostRequestElement('turbo_rates', ''.round(getTurboBonus() / 2).';'.round(getTurboBonus() / 4).'');
	} // END - if

	// Save data
	adminSaveSettingsFromPostData();

	// Remember new settings
	setConfigEntry('bonus_active'        , postRequestElement('bonus_active'));
	setConfigEntry('bonus_enable_notify' , postRequestElement('bonus_enable_notify'));
	setConfigEntry('bonus_disable_notify', postRequestElement('bonus_disable_notify'));
} else {
	// Transfer options to template
	$content['bonus_userid'] = addMemberSelectionBox(getBonusUserid(), FALSE, TRUE, TRUE, 'bonus_userid');

	// Initialize array for the points list
	$RANKS = explode(';', getTurboRates());

	// Automatically calculate bonus points for ranks 2 and 3 when not set
	if (getTurboRates() == '') $RANKS = array(round(getTurboBonus() / 2), round(getTurboBonus() / 4));

	// Generate list
	$OUT = '<ol start="2">';
	$count = '0';
	foreach ($RANKS as $k => $rate) {
		if (!empty($rate)) {
			// Print only when something is in
			$OUT .= '<li><input type="text" name="rate[' . ($k + 2) . ']" class="form_field" size="4" maxlength="7" value="' . $rate . '" /> <div class="notice">({?POINTS?})</div></li>';
		} // END - if
		$count++;
	} // END - foreach

	// Maxmium entries
	$max = 10;
	if ($count >= 8) $max = $count+3;

	// Add more empty fields
	for ($i = $count; $i < $max; $i++) {
		$OUT .= '  <li><input type="text" name="rate[' . ($i+2) . ']" class="form_field" size="4" maxlength="7" /> <div class="notice">({?POINTS?})</div></li>';
	} // END - for
	$OUT .= '</ol>';
	$content['trates_list'] = $OUT;

	// Selection boxes
	$content['login_timeout_selection'] = createConfigurationTimeSelections('login_timeout'    , 'WDh');
	$content['bonus_timeout_selection'] = createConfigurationTimeSelections('bonus_timeout'    , 'WDh');
	$content['wait_selection']          = createConfigurationTimeSelections('bonus_notify_wait', 'ms' );

	// Load final template
	loadTemplate('admin_config_bonus', FALSE, $content);
}

// [EOF]
?>
