<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/28/2003 *
 * ===================                          Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-mem_add.php                                 *
 * -------------------------------------------------------------------- *
 * Short desciption : Add new menu for your members                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Fuegen Sie einen weiteren Menuepunkt zum Mit-    *
 *                     Mitgliedsmenue hinzu                             *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2016 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add desciption as navigation point
addYouAreHereLink('admin', __FILE__);

// Check if the admin has entered title and what-php file name...
if ((!isPostRequestElementSet('title')) && (isFormSent())) {
	unsetPostRequestElement('ok');
} // END - if

if (!isFormSent()) {
	// Create arrays
	$menus  = array();
	$titles = array();
	$below  = array();

	// Get all available main menus
	$result = sqlQuery("SELECT `action`, `title`, `sort` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE (`what`='' OR `what` IS NULL) ORDER BY `sort` ASC",
		__FILE__, __LINE__);
	if (!ifSqlHasZeroNumRows($result)) {
		// Read menu structure
		// @TODO Cant this be rewritten?
		while ($content = sqlFetchArray($result)) {
			// Menu actions
			array_push($menus, $content['action']);

			// Menu titles
			array_push($titles, $content['title']);

			// Below this menu point should the new be added so we simply increase the sort value by 1 :-)
			array_push($below, $content['sort'] + 1);
		} // END - if

		// Free memory
		sqlFreeResult($result);

		// Remove double eintries
		// @TODO This can be somehow rewritten to a function
		$prev = '';
		$dmy  = $menus;
		$dmy2 = $titles;
		$dmy3 = $below;
		foreach ($menus as $key => $value) {
			if ($value == $prev) {
				// Remove entries
				unset($dmy[$key]);
				unset($dmy2[$key]);
				unset($dmy3[$key]);
			} else {
				$prev = $value;
			}
		} // END - foreach

		// Prepare variables
		$menus = $dmy; $titles = $dmy2; $below = $dmy3;

		// Load sub menus :)
		foreach ($menus as $key_main => $value_main) {
			$result = sqlQueryEscaped("SELECT `what`, `title`, `sort` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `action`='%s' AND `what` != '' ORDER BY `sort` ASC",
				array($value_main), __FILE__, __LINE__);
			if (!ifSqlHasZeroNumRows($result)) {
				// Initialize arrays
				$menus[$value_main] = array();
				$titles[$value_main] = array();
				$below[$value_main] = array();

				// Read menu structure
				while ($content = sqlFetchArray($result)) {
					// Menu actions
					array_push($menus[$value_main], $content['what']);

					// Menu titles
					array_push($titles[$value_main], $content['title']);

					// Below this menu point should the new be added so we simply increase the sort value by 1 :-)
					array_push($below[$value_main], $content['sort'] + 1);
				} // END - while

				// Free memory
				sqlFreeResult($result);

				// Remove double eintries
				// @TODO This can be somehow rewritten to a function
				$prev = ''; $dmy = $menus[$value_main]; $dmy2 = $titles[$value_main]; $dmy3 = $below[$value_main];
				foreach ($menus[$value_main] as $key => $value) {
					if ($value == $prev) {
						unset($dmy[$key]);
						unset($dmy2[$key]);
						unset($dmy3[$key]);
					} else {
						$prev = $value;
					}
				} // END - foreach

				// Transfer variables into array
				$menus[$value_main]  = $dmy;
				$titles[$value_main] = $dmy2;
				$below[$value_main]  = $dmy3;
			} // END - if
		} // END - foreach
	} // END - if

	$OUT = '<select class="form_select" name="sort" size="1">
      <option value="">{--ADMIN_IS_FIRST_MENU--}</option>';
	foreach ($below as $key => $m) {
		if (is_array($m)) {
			foreach ($m as $key2 => $m2) {
				$OUT .= '<option value="' . $m2 . '">' . $titles[$key][$key2];
				foreach ($menus as $k => $v) {
					if (($v == $key) && (!is_array($v))) {
						$OUT .= ' (' . $titles[$k] . ')';
					} // END - if
				} // END - foreach
				$OUT .= '</option>';
			} // END - foreach
		} else {
			$OUT .= '<option value="' . $m . '">' . $titles[$key] . '</option>';
		}
	}
	$OUT .= '</select>';

	// Prepare selection boxes for template
	$content['below_selection']  = $OUT;
	$content['what_selection']   = adminAddMenuSelectionBox('member', 'what'  , 'name');
	$content['action_selection'] = adminAddMenuSelectionBox('member', 'action', 'menu');

	// Display form
	loadTemplate('admin_add_member_menu', FALSE, $content);
} elseif (!isDemoModeActive()) {
	// Insert new menu entry
	if (isPostRequestElementSet('menu')) {
		sqlQueryEscaped("INSERT INTO `{?_MYSQL_PREFIX?}_member_menu` (`action`, `what`, `title`, `visible`, `locked`, `sort`) VALUES ('%s','%s','%s','%s','%s','%s')",
			array(
				postRequestElement('menu'),
				postRequestElement('name'),
				postRequestElement('title'),
				postRequestElement('visible'),
				postRequestElement('active'),
				bigintval(postRequestElement('sort')),
			), __FILE__, __LINE__);
	} else {
		sqlQueryEscaped("INSERT INTO `{?_MYSQL_PREFIX?}_member_menu` (`action`, `title`, `visible`, `locked`, `sort`) VALUES ('%s','%s','%s','%s','%s')",
			array(
				postRequestElement('name'),
				postRequestElement('title'),
				postRequestElement('visible'),
				postRequestElement('active'),
				bigintval(postRequestElement('sort')),
			), __FILE__, __LINE__);
	}
	displayMessage('{--SETTINGS_SAVED');
} else {
	// Demo mode!
	displayMessage('{--SETTINGS_NOT_SAVED--}');
}

// [EOF]
?>
